
'  Projekt:       Angry Bird Wing Control
'  Modul:         Statemachine.inc
'  Autor:         Original M. Ruhwald 2019
'                 Modifiziert R. Link 2021
'  BascomAVR:     2.0.8.4

'  Beschreibung:
'  Routinen fr Statemachine-Steuerung


'  ------------------------------------
'  Zustnde der RC-Statemachine
'  ------------------------------------
   Const ST_WING_CENTERED = 1                               ' Flgel in Neutralstellung
   Const ST_WING_FLUTTER = 2                                ' Flgel flattern
   Const ST_WING_STOP = 3                                   ' Flgel bleiben dort stehen, wo sie gerade sind

'  -----------------------------------------
'  Interne Variablen
'  -----------------------------------------
   Dim _FSM_State as Byte                                   ' Zustands-Variable des Automaten
   Dim _FSM_Flags as Byte                                   ' Interne Flags des Automaten
   Const FLAG_CHANGED = 0                                   ' Gesetzt, wenn sich der Zustand gendert hat

'  ------------------------------------
'  Setzen eines neuen Zustandes und markieren als genderten Zustand
'  ------------------------------------
   Sub SetState(Byval state as Byte)
      _FSM_State = state                                    ' Neuer Zustand setzen
      Set _FSM_Flags.FLAG_CHANGED                           ' Zustand hat sich gendert
   End Sub

'  ----------------------------------------------
'  Gibt den aktuellen Zustand zurck
'  ----------------------------------------------
   Function GetState() as Byte
      GetState = _FSM_State                                 ' aktuellen Zustand an Aufrufer
   End Function

'  ----------------------------------------------
'  Gibt TRUE zurck, wenn sich der Zustand
'  seit letzter Abfrage gendert hat.
'  ----------------------------------------------
   Function IsStateChanged() as Byte
      If _FSM_Flags.FLAG_CHANGED = 1 then
         Reset _FSM_Flags.FLAG_CHANGED                      ' Flag gendert nach 1. Abfrage lschen
         IsStateChanged = TRUE                              ' Zustand gendert an Aufrufer
      Else
         IsStateChanged = FALSE                             ' Zustand nicht gendert an Aufrufer
      End If
   End Function


